package moonlander

import kotlin.math.floor

/**
 * Home-made perlin noise.
 */
class PerlinNoise {

	/**
	 * Deterministic random function. Not from me.
	 */
	private fun noise(x: Int, y: Int, z: Int): Float {
		var n = x + y * 57 + z * 997
		n = n shl 13 xor n
		return 1.0f - (n * (n * n * 15731 + 789221) + 1376312589 and 0x7fffffff) / 1073741824.0f
	}

	/** Pairs of (amplitude, frequency) */
	val octaves = ArrayList<Pair<Float, Float>>()

	fun getValue2d(xf: Float, yf: Float, z: Int = 0): Float {
		return octaves.map { (amplitude, frequency) ->
			val x = floor(xf * frequency).toInt()
			val y = floor(yf * frequency).toInt()
			val p00 = noise(x, y, z)
			val p01 = noise(x, y + 1, z)
			val p10 = noise(x + 1, y, z)
			val p11 = noise(x + 1, y + 1, z)
			val fracX = xf * frequency - x
			val fracY = yf * frequency - y
			((1 - fracY) * ((1 - fracX) * p00 + fracX * p10) + fracY * ((1 - fracX) * p01 + fracX * p11)) * amplitude
		}.sum()
	}

}